//+------------------------------------------------------------------+
//|                                                  SDL_TE2_LWMA_v2 |
//|                                    Copyright (c) 2008, latimeria |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2008, latimeria"

/*
 You Need following Custom Indicators.

 <Slope Direction Line Modified 2>
 <Support and Resistance>
 <TrendEnvelopes_v2>

*/

//Trade Switch
extern string  TradeSwitchExp = "<<< Trade Switch >>>";
extern bool    AllowTrade_ExceptM15 = false ;
extern bool    Buy = true ;
extern bool    Sell = true ;
extern bool    WeekendClose = true ;
extern int     WeekendCloseServerTime = 23 ;

//Signal Setting
extern string  SignalExp = "<<< Signal Settings >>>";
extern string  SignalChangeMethod_note = "1=Use4bars,  2=Use 3bars,  3=UseOnlySDL,  4=UseOnlyTE2";
extern int     SignalChangeMethod = 3;
extern bool    UseSignalReverseStop = false;

//Time Anomaly
extern string  TradeTimeExp = "<<< Trade Time Settings >>>";
extern string  AboutTTselect = "0=Anytime, 1=0-6, 2=0-12, 3=6-18, 4=12-18, 5=Other";
extern int     TradeTimeSelect = 5;
extern int     OpenTime = 6;
extern int     EndTime = 20;

//SDL parameters
extern string  SDLParamExp = "<<< SDL Parameters >>>";
extern int     SDL_period = 40;  // PERIOD
extern int     SDL_method = 3;   // MODE_LWMA
extern int     SDL_price = 0;    // PRICE_CLOSE

//LWMA parameters
extern string  LWMAParamExp = "<<< LWMA Parameters >>>";
extern int     LWMA_period = 5;  // PERIOD

//TrendEnvelopes_v2 parameters
extern string  TE2ParamExp = "<<< TE2 Parameters >>>";
extern int     TE2_MAperiod = 10;  // PERIOD
extern int     TE2_MAmethod = 0;   // MODE_SMA

//PositionSizing
extern string  PSExp = "<<< Position Sizing >>>";
extern double  FixLot = 0.1; // if you don't use PS, this lot size is used.
extern bool    PositionSizing = true ;
extern double  PS_RiskRate = 0.3;

//Initial Stop
extern string  InitialSLExp = "<<< Initial StopLoss >>>";
extern string  AboutInitStop = "1=Multiple of Daily ATR,  2=Fixed SL Pips";
extern int     InitialStop_Method = 1 ;
extern int     ATR_Period = 30;
extern double  InitialStopATR = 0.7 ;
extern int     Fixed_SL = 60;

//TakeProfit
extern string  TakeProfitExp = "<<< Take Profit (& StopLoss for S&R)>>>";
extern string  TakeProfit_note = "0=No TP,  1=Multiple of SL,  2=Fixed TP Pips 3=Use S&R";
extern int     TakeProfit_Method = 0;
extern double  TP_Multiple = 1.8;
extern int     Fixed_TP = 150;
extern string  AboutSRMODE = "--- S&R Mode Setting ---";
extern double  SR_Multiple = 0.8;
extern double  TPvsSL_Ratio = 0.8;

//Profit Achieve Stop System
extern string  ProfitAchieveStopExp = "<<< Stop System >>>";
extern bool    UseProfitAchieveStop = false ;
extern string  AboutProfitAchieveStop = "Stop when Profit reaches Account%";
extern double  TakeProfit_Rate = 1;

//Trailing Stop
extern string  TrailMethodExp = "<<< Trailing Stop Method >>>";
extern string  Trail_Method_note = "0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode";
extern int     TRAIL_Method = 1;

extern string  AboutTrail_Method1 = "--- 1. You can change Trailing ATR Multiple ---";
extern double  Trail_ATR = 0.7;
extern string  AboutTrail_Method2 = "--- 2. You can change Trailing Pips ---";
extern int     Trail_Pips = 200;
extern string  AboutTrail_Method3 = "--- 3. You can change Trailing Profit to Reserve ---";
extern double  Profit_to_Reserve = 0.2;

//MA Filter
extern string  MAFilterExp = "<<< MA Filter Settings >>>";
extern bool    UseMAFilter = false;
extern int     F_MA_Period = 100;
extern int     F_MA_Method = 1;
extern int     F_MA_Price = 4;
extern string  F_AboutMATimeFrame = "0=Chart 1=M1 2=M5 3=M15 4=M30 5=H1 6=H4 7=D1";
extern int     F_MA_TimeFrame=0;

//Miscellaneous Settings
extern string  MiscExp = "<<< Miscellaneous Settings >>>";
extern int     Slippage = 3;
extern bool    UseMicrolot = true ;
extern bool    ShowCurrentEntryPrice = true ;
extern bool    ShowStatus = true ;
extern bool    Alert_On = true ;
extern bool    Sound_On = true ;

//magic number
extern int MAGIC = 179382;

//EA name
string  EANAME="SDL_TE2_LWMA_v2";
string  EASHORTNAME="SDL_TE2_LWMA_v2";


//+------------------------------------------------------------------+
//| start                                                            |
//+------------------------------------------------------------------+
int start()
{
	//Get Current Position
   int pos = CalculateCurrentOrders();

// ------ Misc -------------

	//Draw Current Entry Price
   if(ShowCurrentEntryPrice)
   {
      ObjectDelete("CurrentEntry"); 
      if(pos != 0)
      {
         double CurEntryPrice = GetCurrentEntryPrice();
         DrawCurEntryPrice("CurrentEntry", Time[0], CurEntryPrice , Red);
      }
   }
   
   // Show Status
   if(ShowStatus) DrawComment();

// ------ Get indicator values -------------

	//Get SDL values
   double TrendDir_0 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 3, 0); // Trend Direction of Current Bar
   double TrendDir_1 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 3, 1); // Trend Direction of 1 Previous Bar
   double TrendDir_2 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 3, 2); // Trend Direction of 2 Previous Bar
   double TrendDir_3 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 3, 3); // Trend Direction of 3 Previous Bar
   double TrendDir_4 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 3, 4); // Trend Direction of 4 Previous Bar

   double SDL_0 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 0, 0); // SDL LINE of  Previous Bar
   double SDL_1 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 0, 1); // SDL LINE of 1 Previous Bar
   double SDL_2 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 0, 2); // SDL LINE of 2 Previous Bar
   double SDL_3 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 0, 3); // SDL LINE of 3 Previous Bar
   double SDL_4 = iCustom(NULL, 0, "Slope Direction Line Modified 2", SDL_period, SDL_method, SDL_price, 0, 4); // SDL LINE of 4 Previous Bar

	//Get LWMA values
   double LWMA_0 = iMA(NULL,0,LWMA_period,0,MODE_LWMA,PRICE_CLOSE,0);
   double LWMA_1 = iMA(NULL,0,LWMA_period,0,MODE_LWMA,PRICE_CLOSE,1);
   double LWMA_2 = iMA(NULL,0,LWMA_period,0,MODE_LWMA,PRICE_CLOSE,2);
   double LWMA_3 = iMA(NULL,0,LWMA_period,0,MODE_LWMA,PRICE_CLOSE,3);

	//Get TE2 values
   int TE2_Trend_0, TE2_Trend_1, TE2_Trend_2, TE2_Trend_3; double TE2_val_0,TE2_val_1,TE2_val_2,TE2_val_3;
   double DoubleErr = 0.01;

   double TE2_Up_0 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 0, 0); // TE2_Up
   double TE2_Dn_0 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 1, 0); // TE2_Dn
   if(TE2_Up_0 > Bid - Bid*DoubleErr && TE2_Up_0 < Bid + Bid*DoubleErr) { TE2_Trend_0 = 1; TE2_val_0 = TE2_Up_0;} // detect trend and value(1 means up)
   if(TE2_Dn_0 > Bid - Bid*DoubleErr && TE2_Dn_0 < Bid + Bid*DoubleErr) { TE2_Trend_0 = 2; TE2_val_0 = TE2_Dn_0;} // detect trend and value (2 means down)

   double TE2_Up_1 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 0, 1);
   double TE2_Dn_1 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 1, 1);
   if(TE2_Up_1 > Bid - Bid*DoubleErr && TE2_Up_1 < Bid + Bid*DoubleErr) { TE2_Trend_1 = 1; TE2_val_1 = TE2_Up_1;}
   if(TE2_Dn_1 > Bid - Bid*DoubleErr && TE2_Dn_1 < Bid + Bid*DoubleErr) { TE2_Trend_1 = 2; TE2_val_1 = TE2_Dn_1;}

   double TE2_Up_2 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 0, 2);
   double TE2_Dn_2 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 1, 2);
   if(TE2_Up_2 > Bid - Bid*DoubleErr && TE2_Up_2 < Bid + Bid*DoubleErr) { TE2_Trend_2 = 1; TE2_val_2 = TE2_Up_2;}
   if(TE2_Dn_2 > Bid - Bid*DoubleErr && TE2_Dn_2 < Bid + Bid*DoubleErr) { TE2_Trend_2 = 2; TE2_val_2 = TE2_Dn_2;}

   double TE2_Up_3 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 0, 3);
   double TE2_Dn_3 = iCustom(NULL, 0, "TrendEnvelopes_v2", TE2_MAperiod, TE2_MAmethod, 1, 3);
   if(TE2_Up_3 > Bid - Bid*DoubleErr && TE2_Up_3 < Bid + Bid*DoubleErr) { TE2_Trend_3 = 1; TE2_val_3 = TE2_Up_3;}
   if(TE2_Dn_3 > Bid - Bid*DoubleErr && TE2_Dn_3 < Bid + Bid*DoubleErr) { TE2_Trend_3 = 2; TE2_val_3 = TE2_Dn_3;}
   
// ------ Entry_Logic -------------

/*
// Entry Conditions

LONG:
- SDL below LWMA
- TrendEnvelops_v2 below the candle
- SDL and TrendEnvelopes have the same colors

SHORT:
- the opposite of LONG

ENTRY ONLY AT THE OPENING OF SECOND CANDLE AFTER THE SIGNAL.

*/

// check conditions

   int SDLvsLWMA = 0;
   //Check SDL vs LWMA
   if(LWMA_0 > SDL_0 && LWMA_1 > SDL_1) SDLvsLWMA = 1; // 1 means Long
   if(LWMA_0 < SDL_0 && LWMA_1 < SDL_1) SDLvsLWMA = 2; // 2 means Short

   int TE2vsPrice = 0;
   //Check TE2 vs Price
   if(TE2_val_1 < Low[1] && TE2_val_0 < Low[0]) TE2vsPrice = 1; // 1 means Long
   if(TE2_val_1 > High[1] && TE2_val_0 > High[0]) TE2vsPrice = 2; // 2 means Short

   int Trend = 0;
   //Check TE2 and SDL trend
   if(TrendDir_0 > 0 && TrendDir_1 > 0 && TE2_Trend_0 == 1 && TE2_Trend_1 == 1) Trend = 1; // 1 means Long
   if(TrendDir_0 < 0 && TrendDir_1 < 0 && TE2_Trend_0 == 2 && TE2_Trend_1 == 2) Trend = 2; // 2 means Short

// check if trend has changed

   int ChangeTrend = 0; // 1=change long, 2=change short
   int ChangeLongSDL = 0; int ChangeShortSDL = 0; int ChangeLongTE2 = 0; int ChangeShortTE2 = 0;

   if(SignalChangeMethod > 4 || SignalChangeMethod < 1)SignalChangeMethod = 1; // error correction
   
   if(SignalChangeMethod == 1) // 1=Use4bar
   {
      // SDL trend change
      if(TrendDir_0 > 0  && TrendDir_1 > 0 && TrendDir_2 < 0  && TrendDir_3 < 0) ChangeLongSDL = 1;
      if(TrendDir_0 < 0  && TrendDir_1 < 0 && TrendDir_2 > 0  && TrendDir_3 > 0) ChangeShortSDL = 1;

      // TE2 trend change
      if(TE2_Trend_0 == 1  && TE2_Trend_1 == 1 && TE2_Trend_2 == 2  && TE2_Trend_3 == 2) ChangeLongTE2 = 1;
      if(TE2_Trend_0 == 2  && TE2_Trend_1 == 2 && TE2_Trend_2 == 1  && TE2_Trend_3 == 1) ChangeShortTE2 = 1;
      
      // Trend Judge
      if(ChangeLongSDL == 1 && ChangeLongTE2== 1) ChangeTrend = 1; // 1 means trend has changed to long
      if(ChangeShortSDL == 1 && ChangeShortTE2== 1) ChangeTrend = 2; // 2 means trend has changed to short
   }

   if(SignalChangeMethod == 2) // 2=Use 3bar
   {
      // SDL trend change
      if(TrendDir_0 > 0  && TrendDir_1 > 0 && TrendDir_2 < 0) ChangeLongSDL = 1;
      if(TrendDir_0 < 0  && TrendDir_1 < 0 && TrendDir_2 > 0) ChangeShortSDL = 1;

      // TE2 trend change
      if(TE2_Trend_0 == 1  && TE2_Trend_1 == 1 && TE2_Trend_2 == 2) ChangeLongTE2 = 1;
      if(TE2_Trend_0 == 2  && TE2_Trend_1 == 2 && TE2_Trend_2 == 1) ChangeShortTE2 = 1;
      
      // Trend Judge
      if(ChangeLongSDL == 1 && ChangeLongTE2== 1) ChangeTrend = 1;
      if(ChangeShortSDL == 1 && ChangeShortTE2== 1) ChangeTrend = 2;
   }
   
   if(SignalChangeMethod == 3) // 3=UseOnlySDL
   {
      // SDL trend change
      if(TrendDir_0 > 0  && TrendDir_1 > 0 && TrendDir_2 < 0) ChangeLongSDL = 1;
      if(TrendDir_0 < 0  && TrendDir_1 < 0 && TrendDir_2 > 0) ChangeShortSDL = 1;

      // Trend Judge
      if(ChangeLongSDL == 1) ChangeTrend = 1;
      if(ChangeShortSDL == 1) ChangeTrend = 2;
   }

   if(SignalChangeMethod == 4) // 4=UseOnlyTE2
   {
      // TE2 trend change
      if(TE2_Trend_0 == 1  && TE2_Trend_1 == 1 && TE2_Trend_2 == 2) ChangeLongTE2 = 1;
      if(TE2_Trend_0 == 2  && TE2_Trend_1 == 2 && TE2_Trend_2 == 1) ChangeShortTE2 = 1;
      
      // Trend Judge
      if(ChangeLongTE2== 1) ChangeTrend = 1;
      if(ChangeShortTE2== 1) ChangeTrend = 2;
   }

// Judgement

	//Entry Judgement
   int TRADE_DIRECTION = 0;
   if(ChangeTrend == 1 && SDLvsLWMA == 1 && TE2vsPrice == 1 && Trend == 1) TRADE_DIRECTION = 1; //Buy
   if(ChangeTrend == 2 && SDLvsLWMA == 2 && TE2vsPrice == 2 && Trend == 2) TRADE_DIRECTION = 2; //Sell

// ------ MA filter -------------

	//MA Filter
   int F_MA_DIRECTION = 0;
   if(UseMAFilter)
   {
      double F_MA_1 = iMA(NULL,SelectTimeFrame(F_MA_TimeFrame),F_MA_Period,0,F_MA_Method,F_MA_Price,1);
      double F_MA_2 = iMA(NULL,SelectTimeFrame(F_MA_TimeFrame),F_MA_Period,0,F_MA_Method,F_MA_Price,2);
      if(F_MA_1 > F_MA_2) F_MA_DIRECTION = 1; else F_MA_DIRECTION = 2;
      if(TRADE_DIRECTION != F_MA_DIRECTION) TRADE_DIRECTION = 0;
   }
      
// ------ Trailing Stop & Profit Achieve Stop -------------

   // Trailing Stop
   if(TRAIL_Method>3 || TRAIL_Method<0) TRAIL_Method = 1; // error correction
   if( (pos > 0 || pos < 0) && TRAIL_Method != 0 ) MultiModeTrailingStop();
         
   //ProfitAchieveStop
   pos = CalculateCurrentOrders();
   if(pos != 0 && UseProfitAchieveStop) PrifoitAchieveStop();

   // SignalReverse Stop
   if(pos > 0 && UseSignalReverseStop && TRADE_DIRECTION == 2) ClosePositions(); // Close Buy
   if(pos < 0 && UseSignalReverseStop && TRADE_DIRECTION == 1) ClosePositions(); // Close Sell

// ------ Check if EA allows open trade or not -------------

   //work only M15?
   if(Period() != 15 && !AllowTrade_ExceptM15) return(0);

   //WeekEnd Close
   if(WeekendClose) //Close Position and Cancel Trade before WeekEnd
   {
      if (DayOfWeek()==5 && Hour() >= WeekendCloseServerTime) 
      { ClosePositions(); return(0); }
   }

	//Trade Only Bar Opening
   if(Volume[0]>1 || IsTradeAllowed()==false) return(0);

   //Specified Time?  "0=Anytime, 1=0-6, 2=0-12, 3=6-18, 4=12-18, 5=Other"
   switch(TradeTimeSelect)
   {
      case 0: break;
      case 1: if(TimeHour(Time[0]) <= 0 || TimeHour(Time[0]) >= 6) return(0); else break;
      case 2: if(TimeHour(Time[0]) <= 0 || TimeHour(Time[0]) >= 12) return(0); else break;
      case 3: if(TimeHour(Time[0]) <= 6 || TimeHour(Time[0]) >= 18) return(0); else break;
      case 4: if(TimeHour(Time[0]) <= 12 || TimeHour(Time[0]) >= 18) return(0); else break;
      case 5: if(TimeHour(Time[0]) <= OpenTime || TimeHour(Time[0]) >= EndTime) return(0); else break;
      default: break;
   }

// ------ Open Order -------------

	//Open Order
   if(CalculateCurrentOrders() == 0)
   {
      //Buy
      if(TRADE_DIRECTION == 1)
      {
         if(Buy) BuyOrder();
      }

      // Sell
      if(TRADE_DIRECTION == 2)
      {
         if(Sell) SellOrder();
      }
   }

   return(0);
}
// end of Start Function


//+------------------------------------------------------------------+
//| ClosePositions                                                   |
//+------------------------------------------------------------------+
void ClosePositions()
{
   //Total Positions
   int total = OrdersTotal();
   if (total > 0)
   {
      for (int i = total - 1; i >=0; i--)
      {
         //Select Position
         bool selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol())
         {
            //Get Position Type
            int type = OrderType();
            
            bool success = false;
            
            switch (type)
            {
               case OP_BUY:
                  double bid = MarketInfo(OrderSymbol(), MODE_BID);
                  success = OrderClose(OrderTicket(),OrderLots(), bid, 3, CLR_NONE);
                  if(Alert_On) Alert(EASHORTNAME,"_Close ", Symbol(), " at ", Bid," Lots ",OrderLots()); 
                  if(Sound_On) PlaySound("alert2.wav");
                  break;
               case OP_SELL:
                  double ask = MarketInfo(OrderSymbol(), MODE_ASK);
                  success = OrderClose(OrderTicket(),OrderLots(), ask, 3, CLR_NONE);
                  if(Alert_On) Alert(EASHORTNAME,"_Close ", Symbol(), " at ", Ask," Lots ",OrderLots());      
                  if(Sound_On) PlaySound("alert2.wav");
                  break;
            }
            
            if (!success)
            {
               Print("Error code = " + GetLastError());
            }
         }
      }
   }
} // end of ClosePositions Function

//+------------------------------------------------------------------+
//| Culculate Current Open Position                                  |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()
{
   //Open Positionsi+:Buy -:Sellj
   int i;
   int pos=0;

   // Buy Position
   int pos_buy=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      {
         if(OrderType() == OP_BUY) pos_buy++ ;
      }
   }

   //Sell Position
   int pos_sell=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MAGIC)
      {
         if(OrderType() == OP_SELL) pos_sell--;
      }
   }

   //Culculate pos
   if(pos_buy>0) pos = pos_buy;
   if(pos_sell<0) pos = pos_sell;
   if(pos_sell == 0 && pos_buy == 0) pos = 0;

   return(pos);
} // end of CalculateCurrentOrders

//+------------------------------------------------------------------+
//| ATR                                                              |
//+------------------------------------------------------------------+
double ATR()
{
   double ATR = iATR(NULL,1440,ATR_Period,1);
   return(ATR);
}

//+------------------------------------------------------------------+
//| SL_Decision                                                      |
//+------------------------------------------------------------------+
double SL_Decision()
{
   if(InitialStop_Method>2 || InitialStop_Method<1) InitialStop_Method = 1; // error correction
   double SL = Fixed_SL * Point ;
   if(InitialStop_Method == 1) SL = ATR() * InitialStopATR ;
   
   return(SL);
}

//+------------------------------------------------------------------+
//| TP_Decision                                                      |TP_Ratio
//+------------------------------------------------------------------+
double TP_Decision()
{
   if(TakeProfit_Method>3 || TakeProfit_Method<0) TakeProfit_Method = 1; // error correction
   double TP = Fixed_TP * Point ;
   if(TakeProfit_Method==1) TP = SL_Decision() * TP_Multiple ;

   return(TP);
}

//+------------------------------------------------------------------+
//| Position_Sizing                                                  |
//+------------------------------------------------------------------+
double PositionSizing()
{
   double lot = FixLot;
   
   //PositionSizing
   double StopLoss = SL_Decision() ;

   if(PositionSizing)
   {
      double RiskAmount = AccountFreeMargin() * (PS_RiskRate/100) ;
      int SLpips = StopLoss/Point ;
      double PT = profit_unit(); // call function
      lot = RiskAmount/(PT * SLpips) ;
   }

   lot = NormalizeDouble(lot,GetLotDigits()) ;

   return(lot);
}

//+------------------------------------------------------------------+
//| Buy Order                                                        |
//+------------------------------------------------------------------+
void BuyOrder()
{   
   //PositionSizing
   double lot = PositionSizing();
   double StopLoss = Ask - SL_Decision();

   double TP = TP_Decision();
   double TakeProfit = Ask + TP;
   if(TakeProfit_Method==0) TakeProfit = 0 ;

   if(TakeProfit_Method == 3)
   {
      double RESISTANCE = iCustom(NULL, 0, "Support and Resistance", 0, 1); // call "resistance"
      TakeProfit = Ask + (RESISTANCE - Ask) * SR_Multiple ;
      StopLoss = Ask - (TakeProfit * TPvsSL_Ratio);
   }

   if(lot < GetMinimumLot()) return(0);
   bool OrderSuccess = OrderSend(Symbol(), OP_BUY, lot, Ask, Slippage, StopLoss, TakeProfit, EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_B", MAGIC, 0, Green);
   if(OrderSuccess)
   {
      if(Alert_On) Alert(EASHORTNAME," Buy ", Symbol(),"(",GetChartTimeFrame(),") at ", Ask," Lots ",lot);
      if(Sound_On) PlaySound("news.wav");
   }
}

//+------------------------------------------------------------------+
//| Get Minlot                                                       |
//+------------------------------------------------------------------+
double GetMinimumLot()
{
   double ML = 0.1; if(UseMicrolot) ML = 0.01;
   return(ML);
}

//+------------------------------------------------------------------+
//| GetLotDigits                                                     |
//+------------------------------------------------------------------+
int GetLotDigits()
{
   int LotDigits = 1; if(UseMicrolot) LotDigits = 2;
   return(LotDigits);
}

//+------------------------------------------------------------------+
//| Sell Order                                                       |
//+------------------------------------------------------------------+
void SellOrder()
{
   //PositionSizing
   double lot = PositionSizing();
   double StopLoss = Bid + SL_Decision();

   double TP = TP_Decision();
   
   double TakeProfit = Bid - TP;
   if(TakeProfit_Method == 0) TakeProfit = 0 ;

   if(TakeProfit_Method == 3)
   {
      double SUPPORT = iCustom(NULL, 0, "Support and Resistance", 1, 1) * SR_Multiple; // call "support"
      TakeProfit = Bid - (Bid - SUPPORT) ;
      StopLoss = Bid + (TakeProfit * TPvsSL_Ratio);
   }

   if(lot < GetMinimumLot()) return(0);
   bool OrderSuccess = OrderSend(Symbol(), OP_SELL, lot, Bid, Slippage, StopLoss, TakeProfit, EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S", MAGIC, 0, Red);
   if(OrderSuccess)
   {
      if(Alert_On) Alert(EASHORTNAME," Sell ", Symbol(),"(",GetChartTimeFrame(),") at ", Bid," Lots ",lot);
      if(Sound_On) PlaySound("news.wav");      
   }
}


//+------------------------------------------------------------------+
//| profit_unit                                                      |
//+------------------------------------------------------------------+
double profit_unit()
{
    double lot_size    =MarketInfo(Symbol(),MODE_LOTSIZE); //
    string base_currecy=StringSubstr(Symbol(),0,3);
    int    symbol_len  =StringLen(Symbol());
    string term_currecy="USD";
    if(symbol_len==6)
        term_currecy=StringSubstr(Symbol(),3,3);
    string term_pair =term_currecy+AccountCurrency();
    string xterm_pair=AccountCurrency()+term_currecy;
    string base_pair =base_currecy+AccountCurrency();
    double term_unit =1.0;
    if(base_currecy==AccountCurrency())
    { 
        term_unit=1.0/Bid;
    }
    else if(term_currecy!=AccountCurrency())
    {
        term_unit=iClose(term_pair,0,0);
        if(term_unit<=0)
        {
            term_unit=iClose(xterm_pair,0,0);
            if(term_unit<=0)
            {
                term_unit=iClose(base_pair,0,0);
            }
            else
            {
               term_unit=1.0/term_unit;
            }
        }
    }
    return(lot_size*Point*term_unit); // returns Profit/Loss per 1.0 lot * 1pip by your accout currency.
}

//+------------------------------------------------------------------+
//| GetCurrentEntryPrice                                             |
//+------------------------------------------------------------------+
double GetCurrentEntryPrice()
{
   int i; double CurEntryPrice;

   for(i=0; i<OrdersTotal(); i++)
   {
      bool selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
      if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol())
      {
         CurEntryPrice = OrderOpenPrice();
      }
   }
return(CurEntryPrice);
}

//+------------------------------------------------------------------+
//| DrawCurEntryPrice                                                |
//+------------------------------------------------------------------+
void DrawCurEntryPrice(string name, datetime TIME, double PRICE, color COLOR)
  {
   if(CalculateCurrentOrders() > 0) COLOR = Lime;
   if(CalculateCurrentOrders() < 0) COLOR = Red;

   if(ObjectFind(name) == -1)
     {
       ObjectCreate(name, OBJ_ARROW, 0, TIME, PRICE);
       ObjectSet(name, OBJPROP_COLOR, COLOR);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     }
   else
     {
       ObjectSet(name, OBJPROP_TIME1, TIME);
       ObjectSet(name, OBJPROP_PRICE1, PRICE);
       ObjectSet(name, OBJPROP_COLOR, COLOR);
       ObjectSet(name, OBJPROP_WIDTH, 1);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_RIGHTPRICE);
     } 
  }

//+------------------------------------------------------------------+
//| GetChartTimeFrame                                                |
//+------------------------------------------------------------------+
string GetChartTimeFrame()
{   
   //ChartTimeFrame
   string TimeFrame ;
   switch(Period())
   {
      case 1:     TimeFrame = "M1";break;
      case 5:     TimeFrame = "M5"; break;
      case 15:    TimeFrame = "M15"; break;
      case 30:    TimeFrame = "M30"; break;
      case 60:    TimeFrame = "H1"; break;
      case 240:   TimeFrame = "H4"; break;
      case 1440:  TimeFrame = "D1";  break;
      case 10080: TimeFrame = "W1"; break;
      case 43200: TimeFrame = "MN1"; break;
   }
   return(TimeFrame);
}

//+------------------------------------------------------------------+
//| Select Fiter Time Frame                                          |
//+------------------------------------------------------------------+
string SelectTimeFrame(int TIMEFRAME)
{   
   //FilterTimeFrame
   string TimeFrame ;
   switch(TIMEFRAME)
   {
      case 1: TimeFrame = "PERIOD_M1"; break;
      case 2: TimeFrame = "PERIOD_M5"; break;
      case 3: TimeFrame = "PERIOD_M15"; break;
      case 4: TimeFrame = "PERIOD_M30"; break;
      case 5: TimeFrame = "PERIOD_H1"; break;
      case 6: TimeFrame = "PERIOD_H4"; break;
      case 7: TimeFrame = "PERIOD_D1";  break;
      default: F_MA_TimeFrame = 0 ;  break;
   }

   if(F_MA_TimeFrame==0)
   {
      switch(Period())
      {
         case 1:     TimeFrame = "PERIOD_M1";break;
         case 5:     TimeFrame = "PERIOD_M5"; break;
         case 15:    TimeFrame = "PERIOD_M15"; break;
         case 30:    TimeFrame = "PERIOD_M30"; break;
         case 60:    TimeFrame = "PERIOD_H1"; break;
         case 240:   TimeFrame = "PERIOD_H4"; break;
         case 1440:  TimeFrame = "PERIOD_D1";  break;
      }
   }
   
   return(TimeFrame);
}

//+------------------------------------------------------------------+
//| MultiModeTrailingStop                                            |  TRAIL_Method   0=Trail_OFF, 1=ATR_Mode, 2=FixPips_Mode, 3=Profit_Mode 
//+------------------------------------------------------------------+
void MultiModeTrailingStop()
{
   int pos,i;
   double STOP, CurrentSL, STOP_Width, Profit;
   bool selected;

   pos = CalculateCurrentOrders();

   // Get Current Stop Loss
   CurrentSL = CheckCurrentStop();

   if(TRAIL_Method == 1) STOP_Width = ATR()*Trail_ATR ;
   if(TRAIL_Method == 2) STOP_Width = Trail_Pips * Point ;

if(pos > 0) //Buy Position ------------------------------------------------------------------------------
{
   if( (TRAIL_Method == 1 || TRAIL_Method == 2) && Close[1] - STOP_Width > CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] - STOP_Width ;
   
      // Modify Stop Loss (Buy --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY && STOP > OrderStopLoss())
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,OrderTakeProfit(),0,Violet);
         }
      }
   return(0);
   }

   if(TRAIL_Method == 3) // if ProfitMode
   {
      Profit = Bid - CurrentSL; // Culculate Current Profit by pips
      STOP = Bid - (Profit * Profit_to_Reserve);
   
      // Modify Stop Loss (Buy --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY && STOP > OrderStopLoss())
         {
            OrderModify(OrderTicket(),OrderOpenPrice(),STOP,OrderTakeProfit(),0,Violet);
         }
      }
   return(0);
   }

} // end of Buy Trailing --------------------------------------------------------------------------------

if(pos < 0) //Sell Position
{
   // Modify Stop Loss
   if( (TRAIL_Method == 1 || TRAIL_Method == 2) && Close[1] + STOP_Width < CurrentSL) // if ATR or Fixpips Mode
   {
      STOP = Close[1] + STOP_Width ;

      // Modify Stop Loss (Sell --- ATR/FIX)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL && STOP < OrderStopLoss())
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,OrderTakeProfit(),0,Yellow);
         }
      }
   return(0);
   }

   if(TRAIL_Method == 3) // if ProfitMode
   {
      // Modify Stop Loss
      Profit = CurrentSL - Ask ; // Get Current Stop Loss
      STOP = Ask + (Profit * Profit_to_Reserve);

      // Modify Stop Loss (Sell --- Profit)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL && STOP < OrderStopLoss())
         {
            OrderModify(OrderTicket(), OrderOpenPrice(),STOP,OrderTakeProfit(),0,Yellow);
         }
      }
   }

} // end of Sell Trailing --------------------------------------------------------------------------------

} // end of MultiModeTrailing()


//+------------------------------------------------------------------+
//| Get Current StopLoss                                             |
//+------------------------------------------------------------------+
double CheckCurrentStop()
{
   int pos,i;
   double CurrentSL;
   bool selected;
   
   pos = CalculateCurrentOrders();

   if(pos>0) // Buy
   {
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }
   
   if(pos<0) // Sell
   {
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }   
} // end of CheckCurrentStop


//+------------------------------------------------------------------+
//| Profit Achieve Stop                                              |
//+------------------------------------------------------------------+
void PrifoitAchieveStop()
{
   //CurrentProfit
   double CurrentProfit = CheckCurrentProfit();

   //reached Profit_Achieve_Rate ?
   if((CurrentProfit / AccountBalance()) * 100 > TakeProfit_Rate) ClosePositions();
}

//+------------------------------------------------------------------+
//| CheckCurrentProfit                                               |
//+------------------------------------------------------------------+
double CheckCurrentProfit()
{
   int pos,i;
   double CurProfit = 0; double ProfitPips;
   bool selected;
   
   pos = CalculateCurrentOrders();

   if(pos>0) // Buy
   {
      // CheckCurrentProfit(Buy)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            ProfitPips = Bid - OrderOpenPrice() ;
            CurProfit = CurProfit + ( (ProfitPips / Point) * profit_unit() * OrderLots() );
         }
      }
   return(CurProfit);
   }
   
   if(pos<0) // Sell
   {
      // CheckCurrentProfit(Sell)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MAGIC && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            ProfitPips = OrderOpenPrice() - Ask ;
            CurProfit = CurProfit + ( (ProfitPips / Point) * profit_unit() * OrderLots() );
         }
      }
   return(CurProfit);
   }   
} // end of CheckCurrentProfit


//+------------------------------------------------------------------+
//| Show Current Settings                                            |
//+------------------------------------------------------------------+
void DrawComment()
{
   string Dash = "-----------------------------------------------------------------";

   string CurEANAME = EANAME;

//--------------------------------------------------------------------

   string SigMethod_is = "Signal Change Method = ";
   switch(SignalChangeMethod)
   {
      case 1: string Sig_Method = SigMethod_is + "UseSDL&TE2_4bars";break;
      case 2: Sig_Method = SigMethod_is + "UseSDL&TE2_3bars";break;
      case 3: Sig_Method = SigMethod_is + "UseOnlySDL";break;
      case 4: Sig_Method = SigMethod_is + "UseOnlyTE2";break;
      default:Sig_Method = SigMethod_is + "UseSDL&TE2_4bars";break;
  }

//--------------------------------------------------------------------

   switch(SDL_method)
   {
      case 0: string CurSDL_Method = "SMA";break;
      case 1: CurSDL_Method = "EMA";break;
      case 2: CurSDL_Method = "SMMA";break;
      case 3: CurSDL_Method = "LWMA";break;
      default:CurSDL_Method = "SMA";break;
  }
   switch(SDL_price)
   {
      case 0: string CurSDL_Price = "Close";break;
      case 1: CurSDL_Price = "Open";break;
      case 2: CurSDL_Price = "High";break;
      case 3: CurSDL_Price = "Low";break;
      case 4: CurSDL_Price = "Median";break;
      case 5: CurSDL_Price = "Typical";break;
      case 6: CurSDL_Price = "Weighted Close";break;
      default:CurSDL_Price = "Close";break;
  }

   string SDL_Setting = "SDL = MODE_"+CurSDL_Method +" "+SDL_period+ " (Price "+CurSDL_Price+")";

//--------------------------------------------------------------------

   string LWMA_Setting = "LWMA Setting: Period = "+LWMA_period;
   string TE2_Setting = "TE2 Setting: Period = "+TE2_MAperiod+", Method = "+TE2_MAmethod;

//--------------------------------------------------------------------

   // PositionSizing
   string PS_SETTING = "PositionSizing = Off";
   if(PositionSizing) PS_SETTING = "PositionSizing = ON "+"(AccountRisk="+DoubleToStr(PS_RiskRate,1)+"%)";

   // Lot
   string LOT = "Lot = "+DoubleToStr(PositionSizing(),GetLotDigits());
   
   // InitialStop
   string INIT_STOP = "InitialStop = Use Fixed "+Fixed_SL+" pips";
   if(InitialStop_Method==1) INIT_STOP = "InitialStop = Daily ATR Multiple ("+DoubleToStr(InitialStopATR,1)+")";
   if(InitialStop_Method>2 || InitialStop_Method<1) INIT_STOP = "InitialStop = Daily ATR Multiple ("+DoubleToStr(InitialStopATR,1)+")";

//--------------------------------------------------------------------

   // Trailing Stop
   switch(TRAIL_Method)
   {
      case 0: string TRAIL_SETTING = "Off";break;
      case 1: TRAIL_SETTING = "ON - Daily ATR (Multiple="+DoubleToStr(Trail_ATR,1)+")";break;
      case 2: TRAIL_SETTING = "ON - Fixed "+Trail_Pips+" Pips";break;
      case 3: TRAIL_SETTING = "ON - Profit (Reserve="+DoubleToStr(Profit_to_Reserve,1)+")";break;
      default:TRAIL_SETTING = "ON - Daily ATR (Multiple="+DoubleToStr(Trail_ATR,1)+")";break;
   }
   string TRAILINGSTOP = "Trailing Stop = "+TRAIL_SETTING;

   string SIGREVSTOP = "Signal Reverse Stop = Off"; if(UseSignalReverseStop) SIGREVSTOP = "SignalReveseStop = On";

   // TakeProfit
   switch(TakeProfit_Method)
   {
      case 0: string TP_SETTING = "Off";break;
      case 1: TP_SETTING = "Multiple of SL";break;
      case 2: TP_SETTING = "Fixed "+Fixed_TP+" Pips";break;
      case 3: TP_SETTING = "S&R Multiple(Multiple="+DoubleToStr(SR_Multiple,1)+", TPvsSL="+DoubleToStr(TPvsSL_Ratio,1)+")";break;
      default:TP_SETTING = "No TakeProfit";break;
   }
   string TAKEPROFIT = "TakeProfit = "+TP_SETTING;

//--------------------------------------------------------------------

   // MA Filter
   string MA_FILTER = "MA Filter = Off";
   if(UseMAFilter) MA_FILTER = "MA Filter = ON "+"(Method="+F_MA_Method+"/Price="+F_MA_Price+"/TimeFrame="+F_MA_TimeFrame+")";

   // WeekEnd Close
   string WE_CLOSE = "WeekEnd_Close = Off";
   if(WeekendClose) WE_CLOSE = "WeekEnd_Close = ON "+"(Close at "+WeekendCloseServerTime+":00)";

   // Microlot
   string MICROLOT = "Use Microlot = Off";
   if(UseMicrolot) MICROLOT = "Use Microlot = ON";

//--------------------------------------------------------------------

   //Culculate Current Profit
   double CurrentProfit = CheckCurrentProfit();
   double CurrentProfitPercent = ( CurrentProfit / AccountBalance() ) * 100;
   string ProfAchvStop = "Profit Achievement Stop = Off"; if(UseProfitAchieveStop) ProfAchvStop = "Profit Achievement Stop = On ("+DoubleToStr(TakeProfit_Rate,2)+"%)";
   string FlortingPL = "Floating P/L "+DoubleToStr(CurrentProfit,2) + AccountCurrency()+"("+DoubleToStr(CurrentProfitPercent,2)+"%)";

//--------------------------------------------------------------------

   //Specified Time?  "0=Anytime, 1=0-6, 2=0-12, 3=6-18, 4=12-18, 5=Other"
   int FROM, UNTIL;
   switch(TradeTimeSelect)
   {
      case 0: break;
      case 1: FROM =0; UNTIL =6; break;
      case 2: FROM =0; UNTIL =12; break;
      case 3: FROM =6; UNTIL =18; break;
      case 4: FROM =12; UNTIL =18; break;
      case 5: FROM =OpenTime; UNTIL =EndTime; break;
      default: break;
   }
   string TradeTime = "Trade(Entry)Time = from "+FROM+":00 until "+UNTIL+":00";
   if(TradeTimeSelect>5 || TradeTimeSelect<1) TradeTime = "Trade(Entry)Time = Anytime";

//--------------------------------------------------------------------

   switch(DayOfWeek())
   {
      case 0: string DayofWeek = "Sun"; break;
      case 1: DayofWeek = "Mon"; break;
      case 2: DayofWeek = "Tue"; break;
      case 3: DayofWeek = "Wed"; break;
      case 4: DayofWeek = "Thi"; break;
      case 5: DayofWeek = "Fri"; break;
      case 6: DayofWeek = "Sat"; break;
   }
   string CurrentTime = Year()+"/"+Month()+"/"+Day()+"/"+DayofWeek+"/"+Hour()+":"+Minute();

   string SERVER_NAME = AccountServer() ; 

//--------------------------------------------------------------------

   Comment(Dash,"\n",EANAME,"\n",Dash,"\n",Sig_Method,"\n",SDL_Setting,"\n",PS_SETTING,"\n",INIT_STOP,"\n",LOT,"\n",MICROLOT,"\n",Dash,"\n",
   TRAILINGSTOP,"\n",TAKEPROFIT,"\n",SIGREVSTOP,"\n",Dash,"\n",
   FlortingPL,"\n",ProfAchvStop,"\n",Dash,"\n",WE_CLOSE,"\n",MA_FILTER,"\n",TradeTime,"\n",CurrentTime,"\n",SERVER_NAME);

} // end of show status

